# Class BroadPhase

java.lang.Object
com.codename1.gaming.physics.box2d.collision.broadphase.BroadPhase

All Implemented Interfaces:
  `TreeCallback`

public class BroadPhase extends Object implements TreeCallback

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `NULL_PROXY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BroadPhase(BroadPhaseStrategy strategy)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected final void`
  `bufferMove(int proxyId)`
  `final int`
  `createProxy(AABB aabb, Object userData)`
  `final void`
  `destroyProxy(int proxyId)`
  `void`
  `drawTree(DebugDraw argDraw)`
  `AABB`
  `getFatAABB(int proxyId)`
  `final int`
  `getProxyCount()`
  `int`
  `getTreeBalance()`
  `final int`
  `getTreeHeight()`
  `float`
  `getTreeQuality()`
  `Object`
  `getUserData(int proxyId)`
  `final void`
  `moveProxy(int proxyId, AABB aabb, Vec2 displacement)`
  `final void`
  `query(TreeCallback callback, AABB aabb)`
  `final void`
  `raycast(TreeRayCastCallback callback, RayCastInput input)`
  `boolean`
  `testOverlap(int proxyIdA, int proxyIdB)`
  `void`
  `touchProxy(int proxyId)`
  `final boolean`
  `treeCallback(int proxyId)`
  `protected final void`
  `unbufferMove(int proxyId)`
  `final void`
  `updatePairs(PairCallback callback)`

  ### Methods inherited from class Object

  `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### NULL_PROXY

    public static final int NULL_PROXY
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### BroadPhase

    public BroadPhase(BroadPhaseStrategy strategy)

- ## Method Details

  - ### createProxy

    public final int createProxy(AABB aabb, Object userData)

  - ### destroyProxy

    public final void destroyProxy(int proxyId)

  - ### moveProxy

    public final void moveProxy(int proxyId, AABB aabb, Vec2 displacement)

  - ### touchProxy

    public void touchProxy(int proxyId)

  - ### getUserData

    public Object getUserData(int proxyId)

  - ### getFatAABB

    public AABB getFatAABB(int proxyId)

  - ### testOverlap

    public boolean testOverlap(int proxyIdA, int proxyIdB)

  - ### getProxyCount

    public final int getProxyCount()

  - ### drawTree

    public void drawTree(DebugDraw argDraw)

  - ### updatePairs

    public final void updatePairs(PairCallback callback)

  - ### query

    public final void query(TreeCallback callback, AABB aabb)

  - ### raycast

    public final void raycast(TreeRayCastCallback callback, RayCastInput input)

  - ### getTreeHeight

    public final int getTreeHeight()

  - ### getTreeBalance

    public int getTreeBalance()

  - ### getTreeQuality

    public float getTreeQuality()

  - ### bufferMove

    protected final void bufferMove(int proxyId)

  - ### unbufferMove

    protected final void unbufferMove(int proxyId)

  - ### treeCallback

    public final boolean treeCallback(int proxyId)
    Specified by:
      `treeCallback` in interface `TreeCallback`